// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/notebook_service.proto

#include "google/cloud/aiplatform/v1/internal/notebook_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

NotebookServiceTracingConnection::NotebookServiceTracingConnection(
    std::shared_ptr<aiplatform_v1::NotebookServiceConnection> child)
    : child_(std::move(child)) {}

future<StatusOr<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>>
NotebookServiceTracingConnection::CreateNotebookRuntimeTemplate(
    google::cloud::aiplatform::v1::CreateNotebookRuntimeTemplateRequest const&
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::"
      "CreateNotebookRuntimeTemplate");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->CreateNotebookRuntimeTemplate(request));
}

StatusOr<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>
NotebookServiceTracingConnection::GetNotebookRuntimeTemplate(
    google::cloud::aiplatform::v1::GetNotebookRuntimeTemplateRequest const&
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::GetNotebookRuntimeTemplate");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetNotebookRuntimeTemplate(request));
}

StreamRange<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>
NotebookServiceTracingConnection::ListNotebookRuntimeTemplates(
    google::cloud::aiplatform::v1::ListNotebookRuntimeTemplatesRequest
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::ListNotebookRuntimeTemplates");
  internal::OTelScope scope(span);
  auto sr = child_->ListNotebookRuntimeTemplates(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::aiplatform::v1::NotebookRuntimeTemplate>(std::move(span),
                                                              std::move(sr));
}

future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
NotebookServiceTracingConnection::DeleteNotebookRuntimeTemplate(
    google::cloud::aiplatform::v1::DeleteNotebookRuntimeTemplateRequest const&
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::"
      "DeleteNotebookRuntimeTemplate");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteNotebookRuntimeTemplate(request));
}

future<StatusOr<google::cloud::aiplatform::v1::NotebookRuntime>>
NotebookServiceTracingConnection::AssignNotebookRuntime(
    google::cloud::aiplatform::v1::AssignNotebookRuntimeRequest const&
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::AssignNotebookRuntime");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->AssignNotebookRuntime(request));
}

StatusOr<google::cloud::aiplatform::v1::NotebookRuntime>
NotebookServiceTracingConnection::GetNotebookRuntime(
    google::cloud::aiplatform::v1::GetNotebookRuntimeRequest const& request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::GetNotebookRuntime");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetNotebookRuntime(request));
}

StreamRange<google::cloud::aiplatform::v1::NotebookRuntime>
NotebookServiceTracingConnection::ListNotebookRuntimes(
    google::cloud::aiplatform::v1::ListNotebookRuntimesRequest request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::ListNotebookRuntimes");
  internal::OTelScope scope(span);
  auto sr = child_->ListNotebookRuntimes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::aiplatform::v1::NotebookRuntime>(std::move(span),
                                                      std::move(sr));
}

future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
NotebookServiceTracingConnection::DeleteNotebookRuntime(
    google::cloud::aiplatform::v1::DeleteNotebookRuntimeRequest const&
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::DeleteNotebookRuntime");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteNotebookRuntime(request));
}

future<StatusOr<google::cloud::aiplatform::v1::UpgradeNotebookRuntimeResponse>>
NotebookServiceTracingConnection::UpgradeNotebookRuntime(
    google::cloud::aiplatform::v1::UpgradeNotebookRuntimeRequest const&
        request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::UpgradeNotebookRuntime");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->UpgradeNotebookRuntime(request));
}

future<StatusOr<google::cloud::aiplatform::v1::StartNotebookRuntimeResponse>>
NotebookServiceTracingConnection::StartNotebookRuntime(
    google::cloud::aiplatform::v1::StartNotebookRuntimeRequest const& request) {
  auto span = internal::MakeSpan(
      "aiplatform_v1::NotebookServiceConnection::StartNotebookRuntime");
  internal::OTelScope scope(span);
  return internal::EndSpan(std::move(span),
                           child_->StartNotebookRuntime(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<aiplatform_v1::NotebookServiceConnection>
MakeNotebookServiceTracingConnection(
    std::shared_ptr<aiplatform_v1::NotebookServiceConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<NotebookServiceTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google
