// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/llm_utility_service.proto

#include "google/cloud/aiplatform/v1/llm_utility_connection.h"
#include "google/cloud/aiplatform/v1/internal/llm_utility_connection_impl.h"
#include "google/cloud/aiplatform/v1/internal/llm_utility_option_defaults.h"
#include "google/cloud/aiplatform/v1/internal/llm_utility_stub_factory.h"
#include "google/cloud/aiplatform/v1/internal/llm_utility_tracing_connection.h"
#include "google/cloud/aiplatform/v1/llm_utility_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/common_options.h"
#include "google/cloud/credentials.h"
#include "google/cloud/grpc_options.h"
#include "google/cloud/internal/unified_grpc_credentials.h"
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace aiplatform_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

LlmUtilityServiceConnection::~LlmUtilityServiceConnection() = default;

StatusOr<google::cloud::aiplatform::v1::CountTokensResponse>
LlmUtilityServiceConnection::CountTokens(
    google::cloud::aiplatform::v1::CountTokensRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

StatusOr<google::cloud::aiplatform::v1::ComputeTokensResponse>
LlmUtilityServiceConnection::ComputeTokens(
    google::cloud::aiplatform::v1::ComputeTokensRequest const&) {
  return Status(StatusCode::kUnimplemented, "not implemented");
}

std::shared_ptr<LlmUtilityServiceConnection> MakeLlmUtilityServiceConnection(
    std::string const& location, Options options) {
  internal::CheckExpectedOptions<CommonOptionList, GrpcOptionList,
                                 UnifiedCredentialsOptionList,
                                 LlmUtilityServicePolicyOptionList>(options,
                                                                    __func__);
  options = aiplatform_v1_internal::LlmUtilityServiceDefaultOptions(
      location, std::move(options));
  auto background = internal::MakeBackgroundThreadsFactory(options)();
  auto auth = internal::CreateAuthenticationStrategy(background->cq(), options);
  auto stub = aiplatform_v1_internal::CreateDefaultLlmUtilityServiceStub(
      std::move(auth), options);
  return aiplatform_v1_internal::MakeLlmUtilityServiceTracingConnection(
      std::make_shared<aiplatform_v1_internal::LlmUtilityServiceConnectionImpl>(
          std::move(background), std::move(stub), std::move(options)));
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1
}  // namespace cloud
}  // namespace google
